function valmax=opb(M,T,MC,rhot,sigma)

%Compute the uniform regret over all probability distributions

%% Sigma=0: Systematic Over-penalization ([GPS15])
%% Sigma=1: Penalization without over-penalization (LP09])
%% MC:      Number of MC simulation 
%  Rhot: value of gamma_n/rho_n
%% Initial value of gamma_n=1/sqrt(C+1)
C=4;

valmax=zeros(1,M);

%%% pA \otimes pB grid for any possible choices of (pA,pB)
 pA=linspace(0.01,0.98,10);
 pB=linspace(0.05,0.95,10);

 %valmax will record the maximal value over (pA,pB) of the regret(n)/sqrt(n)
valmax=zeros(1,M);
 

for k=1:length(pA)
    for l=1:length(pB)
 %% No computation needed if pA<pB
        if pA(k)<pB(l)     
         valmax=valmax;     
        else
         [pA(k),pB(l)]         
         Stock=zeros(1,M);
         for j=1:MC
            x=1/2;Regret=(1-x);
            %% Technical setting for recording the results
            compt=T/M;compt1=T/M;
            for i=1:T
                %%% U for the arm choice, V for the reward
                U=rand;V=rand;
                gam=1/sqrt(i+C);rho=rhot*gam;               
                if U<x     %% Arm A is chosen
                    res=(V<pA(k));                   
                    x=x+gam*(1-x)*res-rho*gam*x*(1-res*(rand<sigma));
                else       %% Arm B is chosen    
                    res=(V<pB(l));                    
                    x=x-gam*x*res+rho*gam*(1-x)*(1-res*(rand<sigma));
                end
                Regret=Regret+(1-x);
                if i==compt
                    %%% Recording the results
                    Stock(compt/compt1)=Stock(compt/compt1)+Regret/sqrt(i);
                    compt=compt+compt1;
                end
            end
         end
 valmax=max(valmax,Stock*(pA(k)-pB(l))/MC);
        end
     end   
end
